#include <errno.h>
#include <malloc.h>
#include <mpi.h>
#include <mpe.h>

#ifndef COMM_H
#define COMM_H

struct group_info
{
   int  my_address;
   MPI_Group  group;
   MPI_Comm   comm;
   int  number_of_tasks;
};

typedef struct group_info group_info;

struct grid_info
{
   /* comm info. */
   int  my_address;
   int  number_of_tasks;

   /* grid info */
   int  dimension;
   int *dimension_rank;
   int *periods;
   int *Position;

   MPI_Group  group;
   MPI_Comm   comm;

   /* row info */
   group_info row;

   /* column info */
   group_info col;
};

typedef struct grid_info grid_info;

struct global_info
{

   group_info global;
   grid_info  grid;
};

typedef struct global_info global_info;

typedef struct mcb * CMMD_mcb;

#ifdef MACHINE_MAIN
global_info machine_info;
#else
extern global_info machine_info;
#endif
#endif
